export default{
	data : function(){
		return {
			teams:[],
            news: [],
			id: 1,
			name:'',
			description:'',
			teamClicked: false,
			homeClicked: false,
			errMessage:'',
			edit:false,
			idxEdit:null
		}
	},
	methods: {
		clickTeams: function() {
			if(!this.teamClicked){
				this.teamClicked=true;
				this.homeClicked=false;
			}
			else{
				this.teamClicked=false;
			}
		},
		clickHome: function() {
			if(!this.homeClicked){
                const api = new NewsService();
                this.news = api.getNews();
				console.log(this.news);
				this.homeClicked=true;
				this.teamClicked=false;
                let infos = api.getNews();
                console.log(infos)
                this.news = infos
			}
			else{
				this.homeClicked=false;
			}
		},
		checkFields: function() {
			this.errMessage="";
			document.querySelector("#name").removeAttribute("style");
			document.querySelector("#desc").removeAttribute("style");
			if(this.name===""||this.description===""){
				this.errMessage+="The";
				if(this.name===""){
					this.errMessage+=" name";
					document.querySelector("#name").setAttribute("style","border: 1px solid #d66");
				}
				if(this.description===""){
					this.errMessage+=" description";
					document.querySelector("#desc").setAttribute("style","border: 1px solid #d66");
				}
				this.errMessage+=" field must be required ";
			}
			else{
				if(this.name.lenght<5){
					this.errMessage+="The name must have at least 5 caracters ";
				}
				if(this.description.lenght<20){
					this.description+="The description must have at least 20 caracters ";
				}
			}
			if(this.errMessage.length===0){
				this.addTeam();
			}
		},
		addTeam: function(){
			let team = new Team(this.id, this.name, this.description);
			console.log(team);
			if(!this.edit){//adding a team
				this.teams.push(team);
				this.name='';
				this.description='';
				this.id=this.id+1
			}
			else{//editing a team
				this.teams[this.idxEdit]=team;
				this.name='';
				this.description='';
				this.edit=false;
			}
		},
		editTeam: function (team) {
			this.edit=!this.edit;
			this.teams.forEach((e,idx) => {
				if(e.id==team.id&&e.name==team.name&&e.description==team.description){
					this.idxEdit=idx;
				}
			});
			if(this.edit){
				this.name=team.name	;
				this.description=team.description;
			}
			else{
				this.name='';
				this.description='';
			}
		},
		Export:function(){
			console.log(JSON.stringify(this.teams))
		}
	},
	template: 
		`
			<div>
				<span @click="clickHome" style="cursor: pointer">Home</span>
				<span @click="clickTeams" style="cursor: pointer">Teams</span>
				<span>Results</span>
			</div>

			<home-module v-if="homeClicked" :news=this.news></home-module>

			<div id="Teams" v-if="teamClicked">
				<form @submit.prevent>
				<br>
				<label>{{errMessage}}</label><br/>
			
				<div>
					<label>Name</label><br/>
					<input id="name" type="text" v-model="name"/>
				</div>

				<div>
					<label>Description</label><br/>
					<textarea id="desc" v-model="description"></textarea>
				</div>

				<input type="submit" value="Submit" v-on:click="checkFields"/>
				</form>
				<team-card @edit-team="editTeam" v-for="team in teams"
					:id="team.id"
					:nom="team.name"
					:description="team.description">
	 			</team-card>
				<input type="submit" value="Export" v-if="teams.length>0" v-on:click="Export" />
			</div>
		`
}
